Index: examples/creddy_prover_tests/.runall
===================================================================
--- examples/creddy_prover_tests/.runall	(revision 43478b16e8697c54d12a0441fd70b97bfbc96a1b)
+++ 	(revision )
@@ -1,41 +1,0 @@
-#!/bin/sh 
-
-# format,
-#   runall clean
-#   runall setup
-#   runall run
-
-progname=$(basename $0)
-pwd=`pwd`
-
-if [ $# -eq 0 ]; then
-    echo "Usage: $progname (clean|setup|run)" >&2;
-    exit 1
-fi
-
-
-UID=`id | sed -e 's/ .*//' | sed -e 's/.*(//' | sed -e 's/)//'`
-if [ $UID = "mei" ]; then
-    ABAC_PROVER_PATH="../../../libabac"
-    else
-    ABAC_PROVER_PATH=`which abac_prover_yap | sed 's/\/abac_prover_yap//'`
-fi
-export ABAC_PROVER_PATH
-
-for i in `ls -1 `; do
-   if [ -d $i ]; then
-       cd $i
-       if [ "$1" = "clean" ]; then
-           rm -rf ../allout.sha ../allout.cn
-           printf "\n ==> CLEANING on %s\n" "$i" >& 2 ;
-           rm -rf *.der *.pem creds_dump
-       elif [ "$1" = "setup" ]; then
-           printf "\n ==> SETUP on %s\n" "$i"  >& 2;
-           ./README
-       elif [ "$1" = "run" ] ; then
-           printf "\n ==> RUN on %s\n" "$i" ;
-           ./run_query 
-       fi 
-       cd $pwd
-   fi
-done
Index: examples/creddy_prover_tests/Makefile
===================================================================
--- examples/creddy_prover_tests/Makefile	(revision 658e7ef6636fd7814aa21793979cf4ab63120ff5)
+++ examples/creddy_prover_tests/Makefile	(revision 658e7ef6636fd7814aa21793979cf4ab63120ff5)
@@ -0,0 +1,40 @@
+
+DIRECTORY=access_rt2 acme_friend_rt1 acme_rockets_intersection_rt0 acme_rockets_rt0 alice_rt1 alumni2_rt1 alumni3_rt1 alumni_rt1 balltime_rt2 evaluator_rt1 experiment_create_rt0 file_read_rt2 fruits_rt2 leader_rt1 payraise_rt1
+
+.PHONY : setup runcheck clean 
+
+clean:
+	@for i in $(DIRECTORY); do \
+	here=`pwd`; \
+	printf "\n ==> CLEANING on %s\n" "$$i"; \
+	cd $$i; \
+	rm -rf *.der *.pem *.cn *.sha *.log creds_dump; \
+	cd $$here; \
+	done 
+	@rm -rf allout.cn allout.sha
+
+setup: 
+	@for i in $(DIRECTORY); do \
+	here=`pwd`; \
+	cd $$i; \
+	./README 1 >/dev/null 2>&1; \
+	cd $$here; \
+	done
+
+runcheck: 
+	@echo 'running libabac CREDDY/ABAC_PROVER_YAP testing...' 
+	@make setup
+	@for i in $(DIRECTORY); do \
+	here=`pwd`; \
+	cd $$i; \
+	printf "\n ==> RUN on %s\n" "$$i" >> allout.sha; \
+	./run_query >> ../allout.sha 2>/dev/null; \
+	printf "\n ==> RUN on %s\n" "$$i" >> ../allout.cn; \
+	env ABAC_CN=1 ./run_query >> ../allout.cn 2>/dev/null; \
+	cd $$here; \
+	done
+	@if test `diff -q allout.save allout.cn |wc -l ` -eq 0 ; \
+	then echo "   PASSED"; \
+	else echo "   ERROR:got changes!!!"; \
+	fi
+
Index: examples/creddy_prover_tests/access_rt2/run_query
===================================================================
--- examples/creddy_prover_tests/access_rt2/run_query	(revision 43478b16e8697c54d12a0441fd70b97bfbc96a1b)
+++ examples/creddy_prover_tests/access_rt2/run_query	(revision 658e7ef6636fd7814aa21793979cf4ab63120ff5)
@@ -5,5 +5,10 @@
 pwd=`pwd`
 
-eloc=${ABAC_PROVER_PATH}
+eloc=`which abac_prover_yap | sed 's/\/abac_prover_yap//'`
+if [ "$eloc" = "" ]; then
+  echo "ERROR: abac_prover_yap is not in the search path!!!"
+  exit 1
+fi
+
 keyloc=$pwd
 
Index: examples/creddy_prover_tests/acme_friend_rt1/run_query
===================================================================
--- examples/creddy_prover_tests/acme_friend_rt1/run_query	(revision 43478b16e8697c54d12a0441fd70b97bfbc96a1b)
+++ examples/creddy_prover_tests/acme_friend_rt1/run_query	(revision 658e7ef6636fd7814aa21793979cf4ab63120ff5)
@@ -4,5 +4,9 @@
 pwd=`pwd`
 
-eloc=${ABAC_PROVER_PATH}
+eloc=`which abac_prover_yap | sed 's/\/abac_prover_yap//'`
+if [ "$eloc" = "" ]; then
+  echo "ERROR: abac_prover_yap is not in the search path!!!"
+  exit 1
+fi
 keyloc=$pwd
 
Index: examples/creddy_prover_tests/acme_rockets_intersection_rt0/run_query
===================================================================
--- examples/creddy_prover_tests/acme_rockets_intersection_rt0/run_query	(revision 43478b16e8697c54d12a0441fd70b97bfbc96a1b)
+++ examples/creddy_prover_tests/acme_rockets_intersection_rt0/run_query	(revision 658e7ef6636fd7814aa21793979cf4ab63120ff5)
@@ -4,5 +4,9 @@
 pwd=`pwd`
 
-eloc=${ABAC_PROVER_PATH}
+eloc=`which abac_prover_yap | sed 's/\/abac_prover_yap//'`
+if [ "$eloc" = "" ]; then
+  echo "ERROR: abac_prover_yap is not in the search path!!!"
+  exit 1
+fi
 keyloc=$pwd
 
Index: examples/creddy_prover_tests/acme_rockets_rt0/run_query
===================================================================
--- examples/creddy_prover_tests/acme_rockets_rt0/run_query	(revision 43478b16e8697c54d12a0441fd70b97bfbc96a1b)
+++ examples/creddy_prover_tests/acme_rockets_rt0/run_query	(revision 658e7ef6636fd7814aa21793979cf4ab63120ff5)
@@ -3,6 +3,9 @@
 
 pwd=`pwd`
-
-eloc=${ABAC_PROVER_PATH}
+eloc=`which abac_prover_yap | sed 's/\/abac_prover_yap//'`
+if [ "$eloc" = "" ]; then
+  echo "ERROR: abac_prover_yap is not in the search path!!!"
+  exit 1
+fi
 keyloc=$pwd
 
Index: examples/creddy_prover_tests/alice_rt1/run_query
===================================================================
--- examples/creddy_prover_tests/alice_rt1/run_query	(revision 43478b16e8697c54d12a0441fd70b97bfbc96a1b)
+++ examples/creddy_prover_tests/alice_rt1/run_query	(revision 658e7ef6636fd7814aa21793979cf4ab63120ff5)
@@ -3,6 +3,9 @@
 
 pwd=`pwd`
-
-eloc=${ABAC_PROVER_PATH}
+eloc=`which abac_prover_yap | sed 's/\/abac_prover_yap//'`
+if [ "$eloc" = "" ]; then
+  echo "ERROR: abac_prover_yap is not in the search path!!!"
+  exit 1
+fi
 keyloc=$pwd
 
Index: examples/creddy_prover_tests/alumni2_rt1/run_query
===================================================================
--- examples/creddy_prover_tests/alumni2_rt1/run_query	(revision 43478b16e8697c54d12a0441fd70b97bfbc96a1b)
+++ examples/creddy_prover_tests/alumni2_rt1/run_query	(revision 658e7ef6636fd7814aa21793979cf4ab63120ff5)
@@ -3,6 +3,9 @@
 
 pwd=`pwd`
-
-eloc=${ABAC_PROVER_PATH}
+eloc=`which abac_prover_yap | sed 's/\/abac_prover_yap//'`
+if [ "$eloc" = "" ]; then
+  echo "ERROR: abac_prover_yap is not in the search path!!!"
+  exit 1
+fi
 keyloc=$pwd
 
Index: examples/creddy_prover_tests/alumni3_rt1/run_query
===================================================================
--- examples/creddy_prover_tests/alumni3_rt1/run_query	(revision 43478b16e8697c54d12a0441fd70b97bfbc96a1b)
+++ examples/creddy_prover_tests/alumni3_rt1/run_query	(revision 658e7ef6636fd7814aa21793979cf4ab63120ff5)
@@ -1,7 +1,11 @@
 
 # alumni3_rt1_typed  
+
 pwd=`pwd`
-
-eloc=${ABAC_PROVER_PATH}
+eloc=`which abac_prover_yap | sed 's/\/abac_prover_yap//'`
+if [ "$eloc" = "" ]; then
+  echo "ERROR: abac_prover_yap is not in the search path!!!"
+  exit 1
+fi
 keyloc=$pwd
 
Index: examples/creddy_prover_tests/alumni_rt1/run_query
===================================================================
--- examples/creddy_prover_tests/alumni_rt1/run_query	(revision 43478b16e8697c54d12a0441fd70b97bfbc96a1b)
+++ examples/creddy_prover_tests/alumni_rt1/run_query	(revision 658e7ef6636fd7814aa21793979cf4ab63120ff5)
@@ -3,6 +3,9 @@
 
 pwd=`pwd`
-
-eloc=${ABAC_PROVER_PATH}
+eloc=`which abac_prover_yap | sed 's/\/abac_prover_yap//'`
+if [ "$eloc" = "" ]; then
+  echo "ERROR: abac_prover_yap is not in the search path!!!"
+  exit 1
+fi
 keyloc=$pwd
 
Index: examples/creddy_prover_tests/balltime_rt2/run_query
===================================================================
--- examples/creddy_prover_tests/balltime_rt2/run_query	(revision 43478b16e8697c54d12a0441fd70b97bfbc96a1b)
+++ examples/creddy_prover_tests/balltime_rt2/run_query	(revision 658e7ef6636fd7814aa21793979cf4ab63120ff5)
@@ -3,6 +3,9 @@
 
 pwd=`pwd`
-
-eloc=${ABAC_PROVER_PATH}
+eloc=`which abac_prover_yap | sed 's/\/abac_prover_yap//'`
+if [ "$eloc" = "" ]; then
+  echo "ERROR: abac_prover_yap is not in the search path!!!"
+  exit 1
+fi
 keyloc=$pwd
 
Index: examples/creddy_prover_tests/evaluator_rt1/run_query
===================================================================
--- examples/creddy_prover_tests/evaluator_rt1/run_query	(revision 43478b16e8697c54d12a0441fd70b97bfbc96a1b)
+++ examples/creddy_prover_tests/evaluator_rt1/run_query	(revision 658e7ef6636fd7814aa21793979cf4ab63120ff5)
@@ -3,6 +3,9 @@
 
 pwd=`pwd`
-
-eloc=${ABAC_PROVER_PATH}
+eloc=`which abac_prover_yap | sed 's/\/abac_prover_yap//'`
+if [ "$eloc" = "" ]; then
+  echo "ERROR: abac_prover_yap is not in the search path!!!"
+  exit 1
+fi
 keyloc=$pwd
 
Index: examples/creddy_prover_tests/experiment_create_rt0/run_query
===================================================================
--- examples/creddy_prover_tests/experiment_create_rt0/run_query	(revision 43478b16e8697c54d12a0441fd70b97bfbc96a1b)
+++ examples/creddy_prover_tests/experiment_create_rt0/run_query	(revision 658e7ef6636fd7814aa21793979cf4ab63120ff5)
@@ -3,6 +3,9 @@
 
 pwd=`pwd`
-
-eloc=${ABAC_PROVER_PATH}
+eloc=`which abac_prover_yap | sed 's/\/abac_prover_yap//'`
+if [ "$eloc" = "" ]; then
+  echo "ERROR: abac_prover_yap is not in the search path!!!"
+  exit 1
+fi
 keyloc=$pwd
 
Index: examples/creddy_prover_tests/file_read_rt2/run_query
===================================================================
--- examples/creddy_prover_tests/file_read_rt2/run_query	(revision 43478b16e8697c54d12a0441fd70b97bfbc96a1b)
+++ examples/creddy_prover_tests/file_read_rt2/run_query	(revision 658e7ef6636fd7814aa21793979cf4ab63120ff5)
@@ -3,6 +3,9 @@
 
 pwd=`pwd`
-
-eloc=${ABAC_PROVER_PATH}
+eloc=`which abac_prover_yap | sed 's/\/abac_prover_yap//'`
+if [ "$eloc" = "" ]; then
+  echo "ERROR: abac_prover_yap is not in the search path!!!"
+  exit 1
+fi
 keyloc=$pwd
 
Index: examples/creddy_prover_tests/fruits_rt2/run_query
===================================================================
--- examples/creddy_prover_tests/fruits_rt2/run_query	(revision 43478b16e8697c54d12a0441fd70b97bfbc96a1b)
+++ examples/creddy_prover_tests/fruits_rt2/run_query	(revision 658e7ef6636fd7814aa21793979cf4ab63120ff5)
@@ -3,6 +3,9 @@
 
 pwd=`pwd`
-
-eloc=${ABAC_PROVER_PATH}
+eloc=`which abac_prover_yap | sed 's/\/abac_prover_yap//'`
+if [ "$eloc" = "" ]; then
+  echo "ERROR: abac_prover_yap is not in the search path!!!"
+  exit 1
+fi
 keyloc=$pwd
 
Index: examples/creddy_prover_tests/leader_rt1/run_query
===================================================================
--- examples/creddy_prover_tests/leader_rt1/run_query	(revision 43478b16e8697c54d12a0441fd70b97bfbc96a1b)
+++ examples/creddy_prover_tests/leader_rt1/run_query	(revision 658e7ef6636fd7814aa21793979cf4ab63120ff5)
@@ -3,6 +3,9 @@
 
 pwd=`pwd`
-
-eloc=${ABAC_PROVER_PATH}
+eloc=`which abac_prover_yap | sed 's/\/abac_prover_yap//'`
+if [ "$eloc" = "" ]; then
+  echo "ERROR: abac_prover_yap is not in the search path!!!"
+  exit 1
+fi
 keyloc=$pwd
 
Index: examples/creddy_prover_tests/payraise_rt1/run_query
===================================================================
--- examples/creddy_prover_tests/payraise_rt1/run_query	(revision 43478b16e8697c54d12a0441fd70b97bfbc96a1b)
+++ examples/creddy_prover_tests/payraise_rt1/run_query	(revision 658e7ef6636fd7814aa21793979cf4ab63120ff5)
@@ -3,6 +3,9 @@
 
 pwd=`pwd`
-
-eloc=${ABAC_PROVER_PATH}
+eloc=`which abac_prover_yap | sed 's/\/abac_prover_yap//'`
+if [ "$eloc" = "" ]; then
+  echo "ERROR: abac_prover_yap is not in the search path!!!"
+  exit 1
+fi
 keyloc=$pwd
 
Index: examples/creddy_prover_tests/runcheck
===================================================================
--- examples/creddy_prover_tests/runcheck	(revision 43478b16e8697c54d12a0441fd70b97bfbc96a1b)
+++ 	(revision )
@@ -1,23 +1,0 @@
-#!/bin/sh 
-
-rm -rf allout.cn allout.sha
-
-./.runall clean 1 >/dev/null 2>&1
-./.runall setup 1 >/dev/null 2>&1
-
-ABAC_PROVER_PATH=`which abac_prover_yap | sed 's/\/abac_prover_yap//'`
-export ABAC_PROVER_PATH
-
-echo '\n'
-echo 'running libabac CREDDY/ABAC_PROVER_YAP testing...'
-echo '  ---with sha'
-env ./.runall run 1> allout.sha 2>/dev/null
-echo '  ---with cn'
-env ABAC_CN=1 ./.runall run 1> allout.cn 2>/dev/null
-result=`diff allout.cn allout.save`
-
-if [ "$result" = "" ]; then
-   echo "   PASSED"
-else
-   echo "   ERROR:got changes!!!"
-fi