Index: tests/Makefile.am
===================================================================
--- tests/Makefile.am	(revision 92d6ccaa3cb858500fbd0e5076d17e0bc7285da4)
+++ tests/Makefile.am	(revision 831da1840b2798cb659b74e320559e23b7ce050b)
@@ -10,4 +10,8 @@
 # will force the testing to be run with install directory
 #
+# special note: for Cento5 machines that is tightly coupled with
+# python 2.4, need to sed out the invocation python to python2.6
+# (the required version) with
+# find . -type f -print | xargs sed -i 's/env python$/env python2.6/'
 
 include abac.mk
@@ -34,5 +38,5 @@
           export MY_INCLUDES_VAL="$(ABAC_BUILD_INCLUDES_VAL)"; \
 	  cd $$i; \
-	  make -s runcheck | tee -a $$here/result; \
+	  make -i -s runcheck | tee -a $$here/result; \
 	  cd $$here; \
 	done
@@ -47,5 +51,5 @@
 	  here=`pwd`; \
 	  cd $$i; \
-	  make -s runcheck | tee -a $$here/result; \
+	  make -i -s runcheck | tee -a $$here/result; \
 	  cd $$here; \
 	done
Index: tests/attr_tests/Makefile.am
===================================================================
--- tests/attr_tests/Makefile.am	(revision 92d6ccaa3cb858500fbd0e5076d17e0bc7285da4)
+++ tests/attr_tests/Makefile.am	(revision 831da1840b2798cb659b74e320559e23b7ce050b)
@@ -3,5 +3,5 @@
 #
 
-include  ${TESTDIR}/abac.mk
+include  ../abac.mk
 
 EXPECTED_OKAY=3
Index: tests/creddy_prover_tests/Makefile.am
===================================================================
--- tests/creddy_prover_tests/Makefile.am	(revision 92d6ccaa3cb858500fbd0e5076d17e0bc7285da4)
+++ tests/creddy_prover_tests/Makefile.am	(revision 831da1840b2798cb659b74e320559e23b7ce050b)
@@ -3,5 +3,5 @@
 #
 
-include  ${TESTDIR}/abac.mk
+include  ../abac.mk
 
 EXPECTED_OKAY=14
Index: tests/creddy_tests/Makefile.am
===================================================================
--- tests/creddy_tests/Makefile.am	(revision 92d6ccaa3cb858500fbd0e5076d17e0bc7285da4)
+++ tests/creddy_tests/Makefile.am	(revision 831da1840b2798cb659b74e320559e23b7ce050b)
@@ -2,5 +2,5 @@
 # creddy_tests
 #
-include  ${TESTDIR}/abac.mk
+include  ../abac.mk
 
 EXPECTED_OKAY=50
Index: tests/example_scripts/Makefile.am
===================================================================
--- tests/example_scripts/Makefile.am	(revision 92d6ccaa3cb858500fbd0e5076d17e0bc7285da4)
+++ tests/example_scripts/Makefile.am	(revision 831da1840b2798cb659b74e320559e23b7ce050b)
@@ -28,5 +28,5 @@
 	  cd $$i; \
 	  printf "\n ==> RUN on %s\n" "$$i" >> $$here/result ; \
-	  make -s |tee -a $$here/result |grep BAD >> $$here/error; \
+	  make -i -s |tee -a $$here/result |grep BAD >> $$here/error; \
 	  cd $$here; \
 	done
Index: tests/example_scripts/c/Makefile.am
===================================================================
--- tests/example_scripts/c/Makefile.am	(revision 92d6ccaa3cb858500fbd0e5076d17e0bc7285da4)
+++ tests/example_scripts/c/Makefile.am	(revision 831da1840b2798cb659b74e320559e23b7ce050b)
@@ -3,5 +3,5 @@
 #
 
-include  ${TESTDIR}/abac.mk
+include  ../../abac.mk
 
 .PHONY: clean-local 
Index: tests/example_scripts/perl/Makefile.am
===================================================================
--- tests/example_scripts/perl/Makefile.am	(revision 92d6ccaa3cb858500fbd0e5076d17e0bc7285da4)
+++ tests/example_scripts/perl/Makefile.am	(revision 831da1840b2798cb659b74e320559e23b7ce050b)
@@ -3,5 +3,5 @@
 #
 
-include  ${TESTDIR}/abac.mk
+include  ../../abac.mk
 
 .PHONY: clean-local
Index: tests/example_scripts/python/Makefile.am
===================================================================
--- tests/example_scripts/python/Makefile.am	(revision 92d6ccaa3cb858500fbd0e5076d17e0bc7285da4)
+++ tests/example_scripts/python/Makefile.am	(revision 831da1840b2798cb659b74e320559e23b7ce050b)
@@ -3,5 +3,5 @@
 #
 
-include  ${TESTDIR}/abac.mk
+include  ../../abac.mk
 
 .PHONY: clean-local
Index: tests/example_scripts/wiki/Makefile.am
===================================================================
--- tests/example_scripts/wiki/Makefile.am	(revision 92d6ccaa3cb858500fbd0e5076d17e0bc7285da4)
+++ tests/example_scripts/wiki/Makefile.am	(revision 831da1840b2798cb659b74e320559e23b7ce050b)
@@ -3,5 +3,5 @@
 #
 
-include  ${TESTDIR}/abac.mk
+include  ../../abac.mk
 
 .PHONY: runcheck clean-local
Index: tests/python_tests/Makefile.am
===================================================================
--- tests/python_tests/Makefile.am	(revision 92d6ccaa3cb858500fbd0e5076d17e0bc7285da4)
+++ tests/python_tests/Makefile.am	(revision 831da1840b2798cb659b74e320559e23b7ce050b)
@@ -3,5 +3,5 @@
 #
 
-include  ${TESTDIR}/abac.mk
+include  ../abac.mk
 
 EXPECTED_OKAY=11
@@ -37,6 +37,6 @@
 	  cd $$here; \
         done
-	make ids
-	make attrs
+	make -i ids
+	make -i attrs
 	@if test -f error ; \
           then \
Index: tests/scaling_tests/Makefile.am
===================================================================
--- tests/scaling_tests/Makefile.am	(revision 92d6ccaa3cb858500fbd0e5076d17e0bc7285da4)
+++ tests/scaling_tests/Makefile.am	(revision 831da1840b2798cb659b74e320559e23b7ce050b)
@@ -34,5 +34,5 @@
 	  printf "\n ==> RUN on %s\n" "$$i" >> result; \
 	  cd $$i; \
-	  make  runcheck | tee -a $$here/result |grep BAD >> $$here/error; \
+	  make -i runcheck | tee -a $$here/result |grep BAD >> $$here/error; \
 	  cd $$here; \
 	done; 
Index: tests/scaling_tests/daisychain/Makefile.am
===================================================================
--- tests/scaling_tests/daisychain/Makefile.am	(revision 92d6ccaa3cb858500fbd0e5076d17e0bc7285da4)
+++ tests/scaling_tests/daisychain/Makefile.am	(revision 831da1840b2798cb659b74e320559e23b7ce050b)
@@ -21,5 +21,5 @@
 	  here=`pwd`; \
 	  cd $$i; \
-	  make -s test; \
+	  make -i -s test; \
 	  cd $$here;\
 	done;
Index: tests/scaling_tests/daisychain/likes_python/Makefile.am
===================================================================
--- tests/scaling_tests/daisychain/likes_python/Makefile.am	(revision 92d6ccaa3cb858500fbd0e5076d17e0bc7285da4)
+++ tests/scaling_tests/daisychain/likes_python/Makefile.am	(revision 831da1840b2798cb659b74e320559e23b7ce050b)
@@ -3,5 +3,5 @@
 #
 
-include  ${TESTDIR}/abac.mk
+include  ../../../abac.mk
 
 TEST=likes_0 likes_10 likes_20
Index: tests/scaling_tests/haystack/Makefile.am
===================================================================
--- tests/scaling_tests/haystack/Makefile.am	(revision 92d6ccaa3cb858500fbd0e5076d17e0bc7285da4)
+++ tests/scaling_tests/haystack/Makefile.am	(revision 831da1840b2798cb659b74e320559e23b7ce050b)
@@ -21,5 +21,5 @@
 	  here=`pwd`; \
 	  cd $$i; \
-	  make -s test; \
+	  make -i -s test; \
 	  cd $$here;\
 	done;
Index: tests/scaling_tests/haystack/ralphs_prover/Makefile.am
===================================================================
--- tests/scaling_tests/haystack/ralphs_prover/Makefile.am	(revision 92d6ccaa3cb858500fbd0e5076d17e0bc7285da4)
+++ tests/scaling_tests/haystack/ralphs_prover/Makefile.am	(revision 831da1840b2798cb659b74e320559e23b7ce050b)
@@ -3,5 +3,5 @@
 #
 
-include  ${TESTDIR}/abac.mk
+include  ../../../abac.mk
 
 TEST=ralphs_0 ralphs_10 ralphs_20
@@ -31,5 +31,5 @@
 	@make clean
 	cp ../../plotting/run_plot .
-	@make -s test
-	@make -s timing
+	@make -i -s test
+	@make -i -s timing
 	@./run_plot ralphs
Index: tests/scaling_tests/haystack/ralphs_prover/Makefile.in
===================================================================
--- tests/scaling_tests/haystack/ralphs_prover/Makefile.in	(revision 92d6ccaa3cb858500fbd0e5076d17e0bc7285da4)
+++ 	(revision )
@@ -1,425 +1,0 @@
-# Makefile.in generated by automake 1.11.1 from Makefile.am.
-# @configure_input@
-
-# Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
-# 2003, 2004, 2005, 2006, 2007, 2008, 2009  Free Software Foundation,
-# Inc.
-# This Makefile.in is free software; the Free Software Foundation
-# gives unlimited permission to copy and/or distribute it,
-# with or without modifications, as long as this notice is preserved.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY, to the extent permitted by law; without
-# even the implied warranty of MERCHANTABILITY or FITNESS FOR A
-# PARTICULAR PURPOSE.
-
-@SET_MAKE@
-
-#
-# haystack/ralphs_prover
-#
-VPATH = @srcdir@
-pkgdatadir = $(datadir)/@PACKAGE@
-pkgincludedir = $(includedir)/@PACKAGE@
-pkglibdir = $(libdir)/@PACKAGE@
-pkglibexecdir = $(libexecdir)/@PACKAGE@
-am__cd = CDPATH="$${ZSH_VERSION+.}$(PATH_SEPARATOR)" && cd
-install_sh_DATA = $(install_sh) -c -m 644
-install_sh_PROGRAM = $(install_sh) -c
-install_sh_SCRIPT = $(install_sh) -c
-INSTALL_HEADER = $(INSTALL_DATA)
-transform = $(program_transform_name)
-NORMAL_INSTALL = :
-PRE_INSTALL = :
-POST_INSTALL = :
-NORMAL_UNINSTALL = :
-PRE_UNINSTALL = :
-POST_UNINSTALL = :
-build_triplet = @build@
-host_triplet = @host@
-subdir = tests/scaling_tests/haystack/ralphs_prover
-DIST_COMMON = $(srcdir)/Makefile.am $(srcdir)/Makefile.in
-ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
-am__aclocal_m4_deps = $(top_srcdir)/m4/ax_check_openssl.m4 \
-	$(top_srcdir)/m4/ax_check_xml2.m4 \
-	$(top_srcdir)/m4/ax_check_xmlsec1.m4 \
-	$(top_srcdir)/m4/ax_pkg_swig.m4 \
-	$(top_srcdir)/m4/ax_python_devel.m4 \
-	$(top_srcdir)/m4/ax_swig_enable_cxx.m4 \
-	$(top_srcdir)/m4/ax_swig_python.m4 $(top_srcdir)/m4/libtool.m4 \
-	$(top_srcdir)/m4/ltoptions.m4 $(top_srcdir)/m4/ltsugar.m4 \
-	$(top_srcdir)/m4/ltversion.m4 $(top_srcdir)/m4/lt~obsolete.m4 \
-	$(top_srcdir)/configure.ac
-am__configure_deps = $(am__aclocal_m4_deps) $(CONFIGURE_DEPENDENCIES) \
-	$(ACLOCAL_M4)
-mkinstalldirs = $(install_sh) -d
-CONFIG_CLEAN_FILES =
-CONFIG_CLEAN_VPATH_FILES =
-SOURCES =
-DIST_SOURCES =
-DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
-ACLOCAL = @ACLOCAL@
-AMTAR = @AMTAR@
-AR = @AR@
-AUTOCONF = @AUTOCONF@
-AUTOHEADER = @AUTOHEADER@
-AUTOMAKE = @AUTOMAKE@
-AWK = @AWK@
-AX_SWIG_PYTHON_CPPFLAGS = @AX_SWIG_PYTHON_CPPFLAGS@
-AX_SWIG_PYTHON_OPT = @AX_SWIG_PYTHON_OPT@
-CC = @CC@
-CCDEPMODE = @CCDEPMODE@
-CFLAGS = @CFLAGS@
-CPP = @CPP@
-CPPFLAGS = @CPPFLAGS@
-CXX = @CXX@
-CXXCPP = @CXXCPP@
-CXXDEPMODE = @CXXDEPMODE@
-CXXFLAGS = @CXXFLAGS@
-CYGPATH_W = @CYGPATH_W@
-DEFS = @DEFS@
-DEPDIR = @DEPDIR@
-DSYMUTIL = @DSYMUTIL@
-DUMPBIN = @DUMPBIN@
-ECHO_C = @ECHO_C@
-ECHO_N = @ECHO_N@
-ECHO_T = @ECHO_T@
-EGREP = @EGREP@
-EXEEXT = @EXEEXT@
-FGREP = @FGREP@
-GREP = @GREP@
-INSTALL = @INSTALL@
-INSTALL_DATA = @INSTALL_DATA@
-INSTALL_PROGRAM = @INSTALL_PROGRAM@
-INSTALL_SCRIPT = @INSTALL_SCRIPT@
-INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
-LD = @LD@
-LDFLAGS = @LDFLAGS@
-LIBOBJS = @LIBOBJS@
-LIBS = @LIBS@
-LIBTOOL = @LIBTOOL@
-LIPO = @LIPO@
-LN_S = @LN_S@
-LTLIBOBJS = @LTLIBOBJS@
-MAKEINFO = @MAKEINFO@
-MKDIR_P = @MKDIR_P@
-NM = @NM@
-NMEDIT = @NMEDIT@
-OBJDUMP = @OBJDUMP@
-OBJEXT = @OBJEXT@
-OPENSSL_INCLUDES = @OPENSSL_INCLUDES@
-OPENSSL_LDFLAGS = @OPENSSL_LDFLAGS@
-OPENSSL_LIBS = @OPENSSL_LIBS@
-OTOOL = @OTOOL@
-OTOOL64 = @OTOOL64@
-PACKAGE = @PACKAGE@
-PACKAGE_BUGREPORT = @PACKAGE_BUGREPORT@
-PACKAGE_NAME = @PACKAGE_NAME@
-PACKAGE_STRING = @PACKAGE_STRING@
-PACKAGE_TARNAME = @PACKAGE_TARNAME@
-PACKAGE_URL = @PACKAGE_URL@
-PACKAGE_VERSION = @PACKAGE_VERSION@
-PATH_SEPARATOR = @PATH_SEPARATOR@
-PERL = @PERL@
-PKG_CONFIG = @PKG_CONFIG@
-PYTHON = @PYTHON@
-PYTHON_CPPFLAGS = @PYTHON_CPPFLAGS@
-PYTHON_EXEC_PREFIX = @PYTHON_EXEC_PREFIX@
-PYTHON_EXTRA_LDFLAGS = @PYTHON_EXTRA_LDFLAGS@
-PYTHON_EXTRA_LIBS = @PYTHON_EXTRA_LIBS@
-PYTHON_LDFLAGS = @PYTHON_LDFLAGS@
-PYTHON_PLATFORM = @PYTHON_PLATFORM@
-PYTHON_PREFIX = @PYTHON_PREFIX@
-PYTHON_SITE_PKG = @PYTHON_SITE_PKG@
-PYTHON_VERSION = @PYTHON_VERSION@
-RANLIB = @RANLIB@
-SED = @SED@
-SET_MAKE = @SET_MAKE@
-SHELL = @SHELL@
-SITE_PERL = @SITE_PERL@
-STRIP = @STRIP@
-SWIG = @SWIG@
-SWIG_LIB = @SWIG_LIB@
-VERSION = @VERSION@
-XML2_CONFIG = @XML2_CONFIG@
-XML2_INCLUDES = @XML2_INCLUDES@
-XML2_LDFLAGS = @XML2_LDFLAGS@
-XML2_LIBS = @XML2_LIBS@
-XMLSEC1_CONFIG = @XMLSEC1_CONFIG@
-XMLSEC1_INCLUDES = @XMLSEC1_INCLUDES@
-XMLSEC1_LDFLAGS = @XMLSEC1_LDFLAGS@
-XMLSEC1_LIBS = @XMLSEC1_LIBS@
-abs_builddir = @abs_builddir@
-abs_srcdir = @abs_srcdir@
-abs_top_builddir = @abs_top_builddir@
-abs_top_srcdir = @abs_top_srcdir@
-ac_ct_CC = @ac_ct_CC@
-ac_ct_CXX = @ac_ct_CXX@
-ac_ct_DUMPBIN = @ac_ct_DUMPBIN@
-am__include = @am__include@
-am__leading_dot = @am__leading_dot@
-am__quote = @am__quote@
-am__tar = @am__tar@
-am__untar = @am__untar@
-bindir = @bindir@
-build = @build@
-build_alias = @build_alias@
-build_cpu = @build_cpu@
-build_os = @build_os@
-build_vendor = @build_vendor@
-builddir = @builddir@
-datadir = @datadir@
-datarootdir = @datarootdir@
-docdir = @docdir@
-dvidir = @dvidir@
-exec_prefix = @exec_prefix@
-host = @host@
-host_alias = @host_alias@
-host_cpu = @host_cpu@
-host_os = @host_os@
-host_vendor = @host_vendor@
-htmldir = @htmldir@
-includedir = @includedir@
-infodir = @infodir@
-install_sh = @install_sh@
-libdir = @libdir@
-libexecdir = @libexecdir@
-localedir = @localedir@
-localstatedir = @localstatedir@
-lt_ECHO = @lt_ECHO@
-mandir = @mandir@
-mkdir_p = @mkdir_p@
-oldincludedir = @oldincludedir@
-pdfdir = @pdfdir@
-pkgpyexecdir = @pkgpyexecdir@
-pkgpythondir = @pkgpythondir@
-prefix = @prefix@
-program_transform_name = @program_transform_name@
-psdir = @psdir@
-pyexecdir = @pyexecdir@
-pythondir = @pythondir@
-sbindir = @sbindir@
-sharedstatedir = @sharedstatedir@
-srcdir = @srcdir@
-sysconfdir = @sysconfdir@
-target_alias = @target_alias@
-top_build_prefix = @top_build_prefix@
-top_builddir = @top_builddir@
-top_srcdir = @top_srcdir@
-TEST = ralphs_0 ralphs_10 ralphs_20
-TIMING = ralphs_30 ralphs_40 ralphs_50 ralphs_100 ralphs_150 ralphs_200
-all: all-am
-
-.SUFFIXES:
-$(srcdir)/Makefile.in:  $(srcdir)/Makefile.am  $(am__configure_deps)
-	@for dep in $?; do \
-	  case '$(am__configure_deps)' in \
-	    *$$dep*) \
-	      ( cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh ) \
-	        && { if test -f $@; then exit 0; else break; fi; }; \
-	      exit 1;; \
-	  esac; \
-	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign tests/scaling_tests/haystack/ralphs_prover/Makefile'; \
-	$(am__cd) $(top_srcdir) && \
-	  $(AUTOMAKE) --foreign tests/scaling_tests/haystack/ralphs_prover/Makefile
-.PRECIOUS: Makefile
-Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
-	@case '$?' in \
-	  *config.status*) \
-	    cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh;; \
-	  *) \
-	    echo ' cd $(top_builddir) && $(SHELL) ./config.status $(subdir)/$@ $(am__depfiles_maybe)'; \
-	    cd $(top_builddir) && $(SHELL) ./config.status $(subdir)/$@ $(am__depfiles_maybe);; \
-	esac;
-
-$(top_builddir)/config.status: $(top_srcdir)/configure $(CONFIG_STATUS_DEPENDENCIES)
-	cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
-
-$(top_srcdir)/configure:  $(am__configure_deps)
-	cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
-$(ACLOCAL_M4):  $(am__aclocal_m4_deps)
-	cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
-$(am__aclocal_m4_deps):
-
-mostlyclean-libtool:
-	-rm -f *.lo
-
-clean-libtool:
-	-rm -rf .libs _libs
-tags: TAGS
-TAGS:
-
-ctags: CTAGS
-CTAGS:
-
-
-distdir: $(DISTFILES)
-	@srcdirstrip=`echo "$(srcdir)" | sed 's/[].[^$$\\*]/\\\\&/g'`; \
-	topsrcdirstrip=`echo "$(top_srcdir)" | sed 's/[].[^$$\\*]/\\\\&/g'`; \
-	list='$(DISTFILES)'; \
-	  dist_files=`for file in $$list; do echo $$file; done | \
-	  sed -e "s|^$$srcdirstrip/||;t" \
-	      -e "s|^$$topsrcdirstrip/|$(top_builddir)/|;t"`; \
-	case $$dist_files in \
-	  */*) $(MKDIR_P) `echo "$$dist_files" | \
-			   sed '/\//!d;s|^|$(distdir)/|;s,/[^/]*$$,,' | \
-			   sort -u` ;; \
-	esac; \
-	for file in $$dist_files; do \
-	  if test -f $$file || test -d $$file; then d=.; else d=$(srcdir); fi; \
-	  if test -d $$d/$$file; then \
-	    dir=`echo "/$$file" | sed -e 's,/[^/]*$$,,'`; \
-	    if test -d "$(distdir)/$$file"; then \
-	      find "$(distdir)/$$file" -type d ! -perm -700 -exec chmod u+rwx {} \;; \
-	    fi; \
-	    if test -d $(srcdir)/$$file && test $$d != $(srcdir); then \
-	      cp -fpR $(srcdir)/$$file "$(distdir)$$dir" || exit 1; \
-	      find "$(distdir)/$$file" -type d ! -perm -700 -exec chmod u+rwx {} \;; \
-	    fi; \
-	    cp -fpR $$d/$$file "$(distdir)$$dir" || exit 1; \
-	  else \
-	    test -f "$(distdir)/$$file" \
-	    || cp -p $$d/$$file "$(distdir)/$$file" \
-	    || exit 1; \
-	  fi; \
-	done
-check-am: all-am
-check: check-am
-all-am: Makefile
-installdirs:
-install: install-am
-install-exec: install-exec-am
-install-data: install-data-am
-uninstall: uninstall-am
-
-install-am: all-am
-	@$(MAKE) $(AM_MAKEFLAGS) install-exec-am install-data-am
-
-installcheck: installcheck-am
-install-strip:
-	$(MAKE) $(AM_MAKEFLAGS) INSTALL_PROGRAM="$(INSTALL_STRIP_PROGRAM)" \
-	  install_sh_PROGRAM="$(INSTALL_STRIP_PROGRAM)" INSTALL_STRIP_FLAG=-s \
-	  `test -z '$(STRIP)' || \
-	    echo "INSTALL_PROGRAM_ENV=STRIPPROG='$(STRIP)'"` install
-mostlyclean-generic:
-
-clean-generic:
-
-distclean-generic:
-	-test -z "$(CONFIG_CLEAN_FILES)" || rm -f $(CONFIG_CLEAN_FILES)
-	-test . = "$(srcdir)" || test -z "$(CONFIG_CLEAN_VPATH_FILES)" || rm -f $(CONFIG_CLEAN_VPATH_FILES)
-
-maintainer-clean-generic:
-	@echo "This command is intended for maintainers to use"
-	@echo "it deletes files that may require special tools to rebuild."
-clean-am: clean-generic clean-libtool mostlyclean-am
-
-distclean: distclean-am
-	-rm -f Makefile
-distclean-am: clean-am distclean-generic
-
-dvi: dvi-am
-
-dvi-am:
-
-html: html-am
-
-html-am:
-
-info: info-am
-
-info-am:
-
-install-data-am:
-
-install-dvi: install-dvi-am
-
-install-dvi-am:
-
-install-exec-am:
-
-install-html: install-html-am
-
-install-html-am:
-
-install-info: install-info-am
-
-install-info-am:
-
-install-man:
-
-install-pdf: install-pdf-am
-
-install-pdf-am:
-
-install-ps: install-ps-am
-
-install-ps-am:
-
-installcheck-am:
-
-maintainer-clean: maintainer-clean-am
-	-rm -f Makefile
-maintainer-clean-am: distclean-am maintainer-clean-generic
-
-mostlyclean: mostlyclean-am
-
-mostlyclean-am: mostlyclean-generic mostlyclean-libtool
-
-pdf: pdf-am
-
-pdf-am:
-
-ps: ps-am
-
-ps-am:
-
-uninstall-am:
-
-.MAKE: install-am install-strip
-
-.PHONY: all all-am check check-am clean clean-generic clean-libtool \
-	distclean distclean-generic distclean-libtool distdir dvi \
-	dvi-am html html-am info info-am install install-am \
-	install-data install-data-am install-dvi install-dvi-am \
-	install-exec install-exec-am install-html install-html-am \
-	install-info install-info-am install-man install-pdf \
-	install-pdf-am install-ps install-ps-am install-strip \
-	installcheck installcheck-am installdirs maintainer-clean \
-	maintainer-clean-generic mostlyclean mostlyclean-generic \
-	mostlyclean-libtool pdf pdf-am ps ps-am uninstall uninstall-am
-
-
-include  ${TESTDIR}/abac.mk
-
-.PHONY : test clean timing plot 
-all: test
-
-test: $(TEST)
-
-timing: $(TIMING)
-
-ralphs_0 :
-	$(MY_ENV) ./run_one 0
-ralphs_10 :
-	@$(MY_ENV) ./run_one 10
-ralphs_20 :
-	@$(MY_ENV) ./run_one 20
-
-clean:
-	@rm -rf ralphs_* run_plot plot timing dump.file
-
-$(TIMING):
-	@$(MY_ENV) ./run_one $(subst ralphs_,,$@)
-
-plot:
-	@make clean
-	cp ../../plotting/run_plot .
-	@make -s test
-	@make -s timing
-	@./run_plot ralphs
-
-# Tell versions [3.59,3.63) of GNU make to not export all variables.
-# Otherwise a system limit (for SysV at least) may be exceeded.
-.NOEXPORT:
Index: tests/scaling_tests/haystack/ralphs_prover/run_one
===================================================================
--- tests/scaling_tests/haystack/ralphs_prover/run_one	(revision 92d6ccaa3cb858500fbd0e5076d17e0bc7285da4)
+++ tests/scaling_tests/haystack/ralphs_prover/run_one	(revision 831da1840b2798cb659b74e320559e23b7ce050b)
@@ -18,6 +18,5 @@
 chmod +x README run_query
 ./README 1>/dev/null 2>&1
-time env ABAC_CN=1 ./run_query 1>ralphs.tmp 2> ralphs.time
-
+env ABAC_CN=1 ./run_query 1>ralphs.tmp 
 
 s=`grep -c "GOOD" ralphs.tmp 2>/dev/null`
Index: tests/test_util.sh
===================================================================
--- tests/test_util.sh	(revision 92d6ccaa3cb858500fbd0e5076d17e0bc7285da4)
+++ tests/test_util.sh	(revision 831da1840b2798cb659b74e320559e23b7ce050b)
@@ -1,5 +1,5 @@
 #!/bin/sh
 
-debug=1
+debug=0
 
 # look for creddy,