Index: creddy/id.c
===================================================================
--- creddy/id.c	(revision 0cdea0bdbe59a6e4b89a9afff4d68e8e77c67aa3)
+++ creddy/id.c	(revision 1283aa38cf63533e81e9633540c95be880d2096f)
@@ -25,12 +25,12 @@
 
     int refcount;
-}; 
+};
 
 /* Callback configuration */
 struct cb_opts {
-    bool use_prompt;	/* Print a prompt to stderr */
-    bool use_echo;	/* If true, turn off input echo on stdin */
-    unsigned int tries;	/* Number of attempts allowed */
-    char prompt[20];	/* The prompt to display if use_echo is true */
+    bool use_prompt;    /* Print a prompt to stderr */
+    bool use_echo;      /* If true, turn off input echo on stdin */
+    unsigned int tries; /* Number of attempts allowed */
+    char prompt[20];    /* The prompt to display if use_echo is true */
 };
 
@@ -99,6 +99,6 @@
         CRED_PRIVATE_KEY, KEY_RSA,
         BUILD_FROM_FILE, filename,
-	/* Ask for password if the key's encrypted */
-	BUILD_PASSPHRASE_CALLBACK, _passphrase_callback, &c_opts, 
+        /* Ask for password if the key's encrypted */
+        BUILD_PASSPHRASE_CALLBACK, _passphrase_callback, &c_opts,
         BUILD_END
     );
@@ -112,5 +112,5 @@
 /**
  * Generate an ID with the specified CN and validity.
- * 
+ *
  * validity is measured in seconds (as of 0.2.0)
  */
@@ -305,65 +305,65 @@
     /* Configuration options */
     struct cb_opts *opts = (struct cb_opts *) user;
-    chunk_t rv = chunk_empty;	/* Return value, starts empty */
+    chunk_t rv = chunk_empty;   /* Return value, starts empty */
 
     if (try -1 < opts->tries ) {
-	struct termios t;   /* Terminal settings */
-	size_t len = 0;	    /* Length of string from getline */
-	tcflag_t orig = 0;  /* Holds the original local flags (echo in here) */
-
-	if (!opts->use_echo) {
-	    /* Use tc{get,set}attr to turn echo off and restore the intial
-	     * echo settings */
-	    if (!tcgetattr(0, &t)) { 
-		orig = t.c_lflag;
-
-		t.c_lflag &= ~ECHO;
-		if ( tcsetattr(0, TCSANOW, &t) ) { 
-		    perror("Cannot turn off echo"); 
-		    return rv;
-		}
-	    }
-	    else {
-		perror("Cannot turn get attributes to off echo"); 
-		return rv;
-	    }
-	}
-	if (opts->use_prompt) printf("%s", opts->prompt);
-
-	/* Because rv.ptr starts as NULL, getline allocates memory.  The size
-	 * of the allocation returns in rv.len and the size of the string
-	 * (including newline and NUL) is in len.  */
-	if ((rv.ptr = (u_char *) malloc(rv.len = PWLEN))) {
-	    if ( fgets(rv.ptr, rv.len, stdin) ) {
-		/* Readjust the chunk_t's len field to the size of the string
-		 * w/o the newline or NUL */
-		/* would prefer strnlen, but no such luck in FBSD7 or earlier*/
-		size_t len = strlen(rv.ptr);
-
-		if (rv.ptr[len-2] == '\n') rv.len = len-2;
-		else rv.len = len -1;
-	    }
-	    else {
-		/* Read failed.  Deallocate and clear rv */
-		free(rv.ptr);
-		rv = chunk_empty;
-	    }
-	}
-	else {
-	    /* Failed malloc.  Restore rv to empty and return it */
-	    perror("malloc");
-	    rv = chunk_empty;
-	    return rv;
-	}
-
-	if (!opts->use_echo ) {
-	    /* Pop echo beck to its original setting. */
-	    t.c_lflag = orig;
-
-	    if ( tcsetattr(0, TCSANOW, &t) ) 
-		perror("Cannot restore echo setting?"); 
-
-	    if (opts->use_prompt) printf("\n");
-	}
+        struct termios t;   /* Terminal settings */
+        size_t len = 0;     /* Length of string from getline */
+        tcflag_t orig = 0;  /* Holds the original local flags (echo in here) */
+
+        if (!opts->use_echo) {
+            /* Use tc{get,set}attr to turn echo off and restore the intial
+             * echo settings */
+            if (!tcgetattr(0, &t)) {
+                orig = t.c_lflag;
+
+                t.c_lflag &= ~ECHO;
+                if ( tcsetattr(0, TCSANOW, &t) ) {
+                    perror("Cannot turn off echo");
+                    return rv;
+                }
+            }
+            else {
+                perror("Cannot turn get attributes to off echo");
+                return rv;
+            }
+        }
+        if (opts->use_prompt) printf("%s", opts->prompt);
+
+        /* Because rv.ptr starts as NULL, getline allocates memory.  The size
+         * of the allocation returns in rv.len and the size of the string
+         * (including newline and NUL) is in len.  */
+        if ((rv.ptr = (u_char *) malloc(rv.len = PWLEN))) {
+            if ( fgets(rv.ptr, rv.len, stdin) ) {
+                /* Readjust the chunk_t's len field to the size of the string
+                 * w/o the newline or NUL */
+                /* would prefer strnlen, but no such luck in FBSD7 or earlier*/
+                size_t len = strlen(rv.ptr);
+
+                if (rv.ptr[len-2] == '\n') rv.len = len-2;
+                else rv.len = len -1;
+            }
+            else {
+                /* Read failed.  Deallocate and clear rv */
+                free(rv.ptr);
+                rv = chunk_empty;
+            }
+        }
+        else {
+            /* Failed malloc.  Restore rv to empty and return it */
+            perror("malloc");
+            rv = chunk_empty;
+            return rv;
+        }
+
+        if (!opts->use_echo ) {
+            /* Pop echo beck to its original setting. */
+            t.c_lflag = orig;
+
+            if ( tcsetattr(0, TCSANOW, &t) )
+                perror("Cannot restore echo setting?");
+
+            if (opts->use_prompt) printf("\n");
+        }
     }
     else fprintf(stderr, "Too many tries (%d)", try-1);