Index: creddy/compat/readpassphrase.c
===================================================================
--- creddy/compat/readpassphrase.c	(revision 2579c1a1b48df617683bedd12fb71e2a687ec741)
+++ creddy/compat/readpassphrase.c	(revision 2579c1a1b48df617683bedd12fb71e2a687ec741)
@@ -0,0 +1,209 @@
+/*	$OpenBSD: readpassphrase.c,v 1.23 2010/05/14 13:30:34 millert Exp $	*/
+
+/*
+ * Copyright (c) 2000-2002, 2007, 2010
+ *	Todd C. Miller <Todd.Miller@courtesan.com>
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the above
+ * copyright notice and this permission notice appear in all copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+ * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+ * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+ * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
+ * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * Sponsored in part by the Defense Advanced Research Projects
+ * Agency (DARPA) and Air Force Research Laboratory, Air Force
+ * Materiel Command, USAF, under agreement number F39502-99-1-0512.
+ */
+
+/* OPENBSD ORIGINAL: lib/libc/gen/readpassphrase.c */
+
+/**
+ * Tom Carroll <thomas.carroll@pnnl.gov>
+ *
+ * Properly handled tcsetattr and SIGTTOU
+ */
+
+#ifndef HAVE_READPASSPHRASE
+
+#include <ctype.h>
+#include <errno.h>
+#include <fcntl.h>
+#ifdef HAVE_PATHS_H
+# include <paths.h>
+#endif
+#include <signal.h>
+#include <string.h>
+#include <termios.h>
+#include <unistd.h>
+#include "compat/readpassphrase.h"
+
+#ifndef TCSASOFT
+# define TCSASOFT 0
+#endif
+
+#ifndef NSIG
+# ifdef _NSIG
+#  define NSIG _NSIG
+# else
+#  define NSIG 128
+# endif
+#endif
+
+static volatile sig_atomic_t signo[NSIG];
+
+static void handler(int);
+
+char *
+readpassphrase(const char *prompt, char *buf, size_t bufsiz, int flags)
+{
+	ssize_t nr;
+	int input, output, save_errno, i, need_restart;
+	char ch, *p, *end;
+	struct termios term, oterm;
+	struct sigaction sa, savealrm, saveint, savehup, savequit, saveterm;
+	struct sigaction savetstp, savettin, savettou, savepipe;
+
+	/* I suppose we could alloc on demand in this case (XXX). */
+	if (bufsiz == 0) {
+		errno = EINVAL;
+		return(NULL);
+	}
+
+restart:
+	for (i = 0; i < NSIG; i++)
+		signo[i] = 0;
+	nr = -1;
+	save_errno = 0;
+	need_restart = 0;
+	/*
+	 * Read and write to /dev/tty if available.  If not, read from
+	 * stdin and write to stderr unless a tty is required.
+	 */
+	if ((flags & RPP_STDIN) ||
+	    (input = output = open(_PATH_TTY, O_RDWR)) == -1) {
+		if (flags & RPP_REQUIRE_TTY) {
+			errno = ENOTTY;
+			return(NULL);
+		}
+		input = STDIN_FILENO;
+		output = STDERR_FILENO;
+	}
+
+	/*
+	 * Turn off echo if possible.
+	 * If we are using a tty but are not the foreground pgrp this will
+	 * generate SIGTTOU, so do it *before* installing the signal handlers.
+	 */
+	if (input != STDIN_FILENO && tcgetattr(input, &oterm) == 0) {
+		memcpy(&term, &oterm, sizeof(term));
+		if (!(flags & RPP_ECHO_ON))
+			term.c_lflag &= ~(ECHO | ECHONL);
+#ifdef VSTATUS
+		if (term.c_cc[VSTATUS] != _POSIX_VDISABLE)
+			term.c_cc[VSTATUS] = _POSIX_VDISABLE;
+#endif
+		(void)tcsetattr(input, TCSAFLUSH|TCSASOFT, &term);
+	} else {
+		memset(&term, 0, sizeof(term));
+		term.c_lflag |= ECHO;
+		memset(&oterm, 0, sizeof(oterm));
+		oterm.c_lflag |= ECHO;
+	}
+
+	/*
+	 * Catch signals that would otherwise cause the user to end
+	 * up with echo turned off in the shell.  Don't worry about
+	 * things like SIGXCPU and SIGVTALRM for now.
+	 */
+	sigemptyset(&sa.sa_mask);
+	sa.sa_flags = 0;		/* don't restart system calls */
+	sa.sa_handler = handler;
+	(void)sigaction(SIGALRM, &sa, &savealrm);
+	(void)sigaction(SIGHUP, &sa, &savehup);
+	(void)sigaction(SIGINT, &sa, &saveint);
+	(void)sigaction(SIGPIPE, &sa, &savepipe);
+	(void)sigaction(SIGQUIT, &sa, &savequit);
+	(void)sigaction(SIGTERM, &sa, &saveterm);
+	(void)sigaction(SIGTSTP, &sa, &savetstp);
+	(void)sigaction(SIGTTIN, &sa, &savettin);
+	(void)sigaction(SIGTTOU, &sa, &savettou);
+
+	if (!(flags & RPP_STDIN))
+		(void)write(output, prompt, strlen(prompt));
+	end = buf + bufsiz - 1;
+	p = buf;
+	while ((nr = read(input, &ch, 1)) == 1 && ch != '\n' && ch != '\r') {
+		if (p < end) {
+			if ((flags & RPP_SEVENBIT))
+				ch &= 0x7f;
+			if (isalpha(ch)) {
+				if ((flags & RPP_FORCELOWER))
+					ch = (char)tolower(ch);
+				if ((flags & RPP_FORCEUPPER))
+					ch = (char)toupper(ch);
+			}
+			*p++ = ch;
+		}
+	}
+	*p = '\0';
+	save_errno = errno;
+	if (!(term.c_lflag & ECHO))
+		(void)write(output, "\n", 1);
+
+	/* Restore old terminal settings and signals. */
+	if (memcmp(&term, &oterm, sizeof(term)) != 0) {
+		sigset_t ttou_sigset, old_sigset;
+		sigemptyset(&ttou_sigset);
+		sigaddset(&ttou_sigset, SIGTTOU);
+		sigprocmask(SIG_BLOCK, &ttou_sigset, &old_sigset);
+		while (tcsetattr(input, TCSAFLUSH|TCSASOFT, &oterm) == -1 &&
+		    errno == EINTR)
+			continue;
+		sigprocmask(SIG_SETMASK, &old_sigset, NULL);
+	}
+	(void)sigaction(SIGALRM, &savealrm, NULL);
+	(void)sigaction(SIGHUP, &savehup, NULL);
+	(void)sigaction(SIGINT, &saveint, NULL);
+	(void)sigaction(SIGQUIT, &savequit, NULL);
+	(void)sigaction(SIGPIPE, &savepipe, NULL);
+	(void)sigaction(SIGTERM, &saveterm, NULL);
+	(void)sigaction(SIGTSTP, &savetstp, NULL);
+	(void)sigaction(SIGTTIN, &savettin, NULL);
+	(void)sigaction(SIGTTOU, &savettou, NULL);
+	if (input != STDIN_FILENO)
+		(void)close(input);
+
+	/*
+	 * If we were interrupted by a signal, resend it to ourselves
+	 * now that we have restored the signal handlers.
+	 */
+	for (i = 0; i < NSIG; i++) {
+		if (signo[i]) {
+			kill(getpid(), i);
+			switch (i) {
+			case SIGTSTP:
+			case SIGTTIN:
+			case SIGTTOU:
+				need_restart = 1;
+			}
+		}
+	}
+	if (need_restart)
+		goto restart;
+
+	return(nr == -1 ? errno = save_errno, NULL : buf);
+}
+
+static void handler(int s)
+{
+
+	signo[s] = 1;
+}
+
+#endif /* ! HAVE_READPASSPHRASE */
Index: creddy/compat/readpassphrase.h
===================================================================
--- creddy/compat/readpassphrase.h	(revision 2579c1a1b48df617683bedd12fb71e2a687ec741)
+++ creddy/compat/readpassphrase.h	(revision 2579c1a1b48df617683bedd12fb71e2a687ec741)
@@ -0,0 +1,42 @@
+/*	$OpenBSD: readpassphrase.h,v 1.5 2003/06/17 21:56:23 millert Exp $	*/
+
+/*
+ * Copyright (c) 2000, 2002 Todd C. Miller <Todd.Miller@courtesan.com>
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the above
+ * copyright notice and this permission notice appear in all copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+ * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+ * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+ * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
+ * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * Sponsored in part by the Defense Advanced Research Projects
+ * Agency (DARPA) and Air Force Research Laboratory, Air Force
+ * Materiel Command, USAF, under agreement number F39502-99-1-0512.
+ */
+
+#ifndef _READPASSPHRASE_H_
+#define _READPASSPHRASE_H_
+
+#ifndef HAVE_READPASSPHRASE
+
+#define RPP_ECHO_OFF    0x00		/* Turn off echo (default). */
+#define RPP_ECHO_ON     0x01		/* Leave echo on. */
+#define RPP_REQUIRE_TTY 0x02		/* Fail if there is no tty. */
+#define RPP_FORCELOWER  0x04		/* Force input to lower case. */
+#define RPP_FORCEUPPER  0x08		/* Force input to upper case. */
+#define RPP_SEVENBIT    0x10		/* Strip the high bit from input. */
+#define RPP_STDIN       0x20		/* Read from stdin, not /dev/tty */
+
+#include <stddef.h>
+
+char * readpassphrase(const char *, char *, size_t, int);
+
+#endif /* ! HAVE_READPASSPHRASE */
+
+#endif /* !_READPASSPHRASE_H_ */
Index: creddy/id.c
===================================================================
--- creddy/id.c	(revision ef5215530cb61b3c05376e54e150e9acbcb66c07)
+++ creddy/id.c	(revision 2579c1a1b48df617683bedd12fb71e2a687ec741)
@@ -1,5 +1,4 @@
 #include <assert.h>
 #include <err.h>
-#include <termios.h>
 #include <time.h>
 
@@ -14,4 +13,10 @@
 /* Size of password memory allocation */
 #define PWLEN 128
+
+#ifdef HAVE_READPASSPHRASE
+# include <readpassphrase.h>
+#else
+# include "compat/readpassphrase.h"
+#endif
 
 //
@@ -332,70 +337,26 @@
      * a cb_opts struct, which affects this routine in the obvious ways.
      */
+
     /* Configuration options */
     struct cb_opts *opts = (struct cb_opts *) user;
-    chunk_t rv = chunk_empty;   /* Return value, starts empty */
 
     if (try -1 < opts->tries ) {
-        struct termios t;   /* Terminal settings */
-        size_t len = 0;     /* Length of string from getline */
-        tcflag_t orig = 0;  /* Holds the original local flags (echo in here) */
-
-        if (!opts->use_echo) {
-            /* Use tc{get,set}attr to turn echo off and restore the intial
-             * echo settings */
-            if (!tcgetattr(0, &t)) {
-                orig = t.c_lflag;
-
-                t.c_lflag &= ~ECHO;
-                if ( tcsetattr(0, TCSANOW, &t) ) {
-                    perror("Cannot turn off echo");
-                    return rv;
-                }
-            }
-            else {
-                perror("Cannot turn get attributes to off echo");
-                return rv;
-            }
-        }
-        if (opts->use_prompt) printf("%s", opts->prompt);
-
-        /* Because rv.ptr starts as NULL, getline allocates memory.  The size
-         * of the allocation returns in rv.len and the size of the string
-         * (including newline and NUL) is in len.  */
-        if ((rv.ptr = (u_char *) malloc(rv.len = PWLEN))) {
-            if ( fgets(rv.ptr, rv.len, stdin) ) {
-                /* Readjust the chunk_t's len field to the size of the string
-                 * w/o the newline or NUL */
-                /* would prefer strnlen, but no such luck in FBSD7 or earlier*/
-                size_t len = strlen(rv.ptr);
-
-                if (rv.ptr[len-2] == '\n') rv.len = len-2;
-                else rv.len = len -1;
-            }
-            else {
-                /* Read failed.  Deallocate and clear rv */
-                free(rv.ptr);
-                rv = chunk_empty;
-            }
-        }
-        else {
-            /* Failed malloc.  Restore rv to empty and return it */
-            perror("malloc");
-            rv = chunk_empty;
-            return rv;
-        }
-
-        if (!opts->use_echo ) {
-            /* Pop echo beck to its original setting. */
-            t.c_lflag = orig;
-
-            if ( tcsetattr(0, TCSANOW, &t) )
-                perror("Cannot restore echo setting?");
-
-            if (opts->use_prompt) printf("\n");
-        }
+        char *secret = malloc(PWLEN);
+	if(!secret) {
+	    perror("malloc(PWLEN)");
+	    return chunk_empty;
+	}
+	if (readpassphrase(opts->use_prompt ? opts->prompt : NULL, secret, PWLEN, 
+                     opts->use_echo ? RPP_ECHO_ON : RPP_ECHO_OFF) == NULL) {
+          perror("readpassphrase()");
+	  memset(secret, '\0', PWLEN);
+	  free(secret);
+          return chunk_empty;
+	} 
+	return chunk_create(secret, strlen(secret));
+    } else {
+        fprintf(stderr, "Too many tries (%d)", try-1);
+        return chunk_empty;
     }
-    else fprintf(stderr, "Too many tries (%d)", try-1);
-    return rv;
 }
 